/* src/serveur.c - Fonctions serveur
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include "main.h"
#ifdef USEBSD
#include <netinet/in.h>
#endif
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <errno.h>

#ifdef TESTBOT
#include "web2cs.h"

extern fd_set socks, master;
extern int highsock, bind_sock;
extern void w2c_setnonblocking(int);
extern struct w2c_clientinfo *w2c_clihead;
extern int CONtotal, WEBtrafficUP, WEBtrafficDL;
extern w2c_hallow *w2c_hallowhead;
#endif

extern const time_t STS;
extern const int kill_interval;
extern const char *pasdeperm;
extern int lastresetparse;
extern int lastresetlogs;
extern int premiere;

extern struct cs_commands cs_cmds[];
extern void choose_welcome(char *);
#ifdef HAVE_CRYPTHOST
char *hostprot(const char *);
#endif
int isignore(aNick *);

void m_ping(int, char **);
void m_privmsg(int, char **);
void m_pass(int, char **);
void m_kick(int, char **);
void m_part(int, char **);
void m_join(int, char **);

void m_mode(int, char **);
void m_eob(int, char **);
void m_squit(int, char **);
void m_server(int, char **);
void m_create(int, char **);
void m_nick(int, char **);
void m_quit(int, char **);
void m_burst(int, char **);
void m_away(int, char **);
#ifndef N2K
void m_sethost(int, char **);
void m_setident(int, char **);
void m_account(int, char **);
#else
void m_clearmode(int, char **);
#endif
void m_whois(int, char **);
void m_kill(int, char **);
void m_topic(int, char **);

int init_bot(int, int);
void run_bot(int);

