/* include/web2cs.h - Dclarations du Web2CS
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Commandes serveur*/
#define RPL_000 "000 SCoderZ %s (Web2Cs)\n", SPVERSION /* Welcome*/
#define RPL_001 "001 %s\n" /* Fermeture socket*/

/* Commandes globales*/
#define RPL_100 "100\n" /* Succs de la commande*/
#define RPL_101 "101\n" /* Erreur indfinie*/
#define RPL_102 "102\n" /* Ncessite plus d'arg*/
#define RPL_103 "103\n" /* Commande inconnue*/
#define RPL_104 "104 %s\n" /* Sous commande ou option inconnue*/
#define RPL_105 "105 %s\n" /* Username inconnu*/
#define RPL_106 "106 %s\n" /* Salon inconnu*/
#define RPL_107 "107\n" /*Privilges insuffisants*/

/* LOGIN */
#define RPL_210 "210\n" /* Mot de passe incorrect, Login inconnu */
#define RPL_211 "211\n" /* Login accept*/
#define RPL_212 "212 %s\n" /* Dja loggu*/

/* CHANINFO */
#define RPL_220 "220 %s\n" /* Dbut CHANINFO*/
#define RPL_221 "221 %s %s\n" /* Rponse CHANINFO*/
#define RPL_222 "222 %s\n" /* Rponse CHANINFO (users)*/

/* ACCESS*/
#define RPL_230 "230 %s %s %d %s\n" /* Dbut d'un access (chan + username + niveau + authed ? oui : non)*/
#define RPL_231 "231 %s\n" /* Options de l'account*/
#define RPL_232 "232 %d\n" /* Dernire visite (en temps unix)*/
#define RPL_233 "233 %s\n" /* infoline*/
#define RPL_234 "234 %s\n" /* fin de l'information sur l'access en cours (username)*/
#define RPL_235 "235 %d\n" /* fin de la commande ACCESS (indication du nombre d'entre donn*/

/* MYACCESS*/
#define RPL_240 "240 %s\n" /* Dbut MYACCESS*/
#define RPL_241 "241 %s %s\n" /* Rponse MYACCESS*/
#define RPL_242 "242 %s\n" /* Rponse MYACCESS (accs)*/
#define RPL_243 "243 %s\n" /* Rponse MYACCESS (waiting access)*/

/*SET / USER*/
#define RPL_250 "250\n" /* Pseudo invalide/dja utilis*/
#define RPL_251 "251\n" /* mail dj utilis*/

/* MODUSER*/
#define RPL_270 "270 %s %s\n" /* Erreur: l'user n'a pas d'access (chan + user)*/
#define RPL_271 "271 %s %d\n" /* Toggle effectu avec succs (option + 1/0) ou changement level bien mis*/
#define RPL_272 "272 %s\n" /* Infoline mis (rien si NULL)*/

/*CHANOPT*/
#define RPL_280 "280 %s %d\n" /* CHANOPT russi (option + 1/0)*/
#define RPL_281 "281 %s %s\n" /* CHANOPT russi (option + string)*/
#define RPL_282 "282\n" /* err: LOCKTOPIC actif*/
#define RPL_283 "283\n" /* err: vous ne pouvez pas mettre un banlevel plus grand que votre niveau d'access*/

/*MEMOS*/
#define RPL_290 "290 %d %s %d %s\n" /* MEMOS (<read?1/0> <de> <date> <msg>) */
#define RPL_291 "291\n" /* memo cherch non trouv */
#define RPL_292 "292 %d\n" /* fin de la liste des %d memos / les %d memos sont del */
#define RPL_293 "293\n" /* L'user n'accepte pas les memos */
#define RPL_294 "294 %d\n" /* Limite de memos atteinte pour cet user. %d reprsente le nb max de memos */

/*MYACCESS ACCEPT/REFUSE*/
#define RPL_310 "310\n" /* Accept/refuse toutes les propositions d'access */
#define RPL_311 "311\n" /*Pas de proposition d'access pour ce chan*/

struct w2c_clientinfo {
	int socket;
	char ip[16];
	int flag;
#define W2C_ALLOWED 0x001
	struct userinfo *user; /*si il est logu sur un username.. :p*/
	struct w2c_clientinfo *next;
};

 struct w2c_commands {
   char cmd[15];
   int (*func) (struct w2c_clientinfo *cli, struct chaninfo *chaninfo, int parc, char **parv);
   int level;
   int args;
   int chan;
};

typedef struct w2c_allow_hosts {
	char host[16];
	struct w2c_allow_hosts *next;
} w2c_hallow;


/* Prototypes */
int w2c_login(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_moduser(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_chaninfo(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_access(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_set(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_user(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_chan(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_myaccess(struct w2c_clientinfo *, struct chaninfo *, int, char **);
int w2c_whoison(struct w2c_clientinfo *source, aChan *chaninfo, int parc, char **parv);
int w2c_reg_user(struct w2c_clientinfo *source, aChan *chaninfo, int parc, char **parv);
int w2c_chanopt(struct w2c_clientinfo *source, aChan *chaninfo, int parc, char **parv);
int w2c_memos(struct w2c_clientinfo *source, aChan *chaninfo, int parc, char **parv);
int w2c_passwd(struct w2c_clientinfo *source, aChan *chaninfo, int parc, char **parv);

void w2c_parsemsg(struct w2c_clientinfo *, char *);
int w2c_exit_client(struct w2c_clientinfo *, const char *);
void w2c_delclient(struct w2c_clientinfo *);
struct w2c_clientinfo *w2c_findclient(int);
struct w2c_clientinfo *w2c_addclient(int, char *);
int w2c_readsocks(void);
int w2c_checksocks(void);
void w2c_initsocket(void);
void w2c_closesocks(void);
int w2c_sendrpl(struct w2c_clientinfo *, const char *, ...);
void w2c_setnonbloking(int);
