/* src/admin_manage.c - commandes pr gerer les admins
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: admin_manage.c,v 1.8 2003/07/05 10:38:48 romexzf Exp $");


/*
 * admin_level
 *
 * parv[1] = username
 * parv[2] = niveau
 */
int admin_level(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user;
	int niveau;
#ifdef USE_MEMOSERV
	char memo[MEMOLEN + 1];
#endif

	if(!is_num(parv[2])) return csntc(nick, "Le niveau doit tre un nombre.");

	niveau = atoi(parv[2]);
	if(niveau > 4 || niveau < 1)
		return csntc(nick, "Le niveau des admins doit tre entre 2 et 4.");

	if(!(user = getuserinfo(parv[1]))) return csntc(nick, NOSUCHUSER, parv[1]);

	if(!IsAnAdmin(user) && niveau == 1) return csntc(nick, "%s n'est pas Admin.", user->nick);

	if(niveau >= nick->user->level && nick->user->level != 4)
		return csntc(nick, "Vous ne pouvez pas mettre %s  un niveau suprieur ou gal au votre.", user->nick);

	if(niveau == user->level) return csntc(nick, "%s est dj au niveau %d.", user->nick, niveau);
	if(niveau == 1)
	{
		csntc(nick, "%s n'est plus Administrateur.", user->nick);
#ifdef USE_MEMOSERV
		snprintf(memo, MEMOLEN, "Votre accs Administrateur a t supprim par %s.", nick->user->nick);
#endif
	}
	else if(!IsAnAdmin(user))
	{
		csntc(nick, "%s est maintenant Administrateur au niveau\2 %d\2.", user->nick, niveau);
#ifdef USE_MEMOSERV
		snprintf(memo, MEMOLEN, "%s vous a nomm Administrateur.", nick->user->nick);
#endif
	}
	else
	{
		csntc(nick, "Vous modifi le niveau Administrateur de \2%s\2 en\2 %d\2.", user->nick, niveau);
#ifdef USE_MEMOSERV
		snprintf(memo, MEMOLEN, "%s a modifi votre accs administrateur au level %d.", nick->user->nick, niveau);
#endif
	}

#ifdef USE_MEMOSERV
	add_memo(user, "Services", time(NULL), memo, 0);
#endif
	user->level = niveau;
	write_anuser(user);
	return 1;
}
