/* src/chanopt.c - Paramtrage des options salons
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: chanopt.c,v 1.25 2003/08/02 01:56:01 romexzf Exp $");

/*
 * generic_chanopt
 *
 * parv[1] = #salon
 * parv[2] = option
 * parv[3] = argument
 */
int generic_chanopt(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *c = parv[1], *cmd = parv[2];
	int i = 0;

	if(!strcasecmp(cmd, "setwelcome"))
	{
		if(CSetWelcome(chaninfo)) DelCSetWelcome(chaninfo);
		else SetCSetWelcome(chaninfo);
		csntc(nick, "Le message de bienvenue de \2%s\2 a t %sactiv.", c,	CSetWelcome(chaninfo) ? "" : "des");
	}

	else if(!strcasecmp(cmd, "defmodes"))
	{
		char *mode;
		if(parc < 3)
			return csntc(nick, "Syntaxe: %s #salon DEFMODES <modes>", RealCmd("chanopt"));

		if(*parv[3] != '+' || strchr(parv[3],'-'))
			return csntc(nick, "Veuillez prciser des modes valides (Seulement des modes  mettre [+modes]).");

		mode = parv[3];
		if(strchr(mode, 'o') || strchr(mode, 'b') || strchr(mode, 'v'))
			return csntc(nick, "Vous n'tes pas autoris  changer les Ops,Voices,Bans avec cette commande.");

		if(!(nick->flag & N_OPER) && strchr(mode, 'O'))
			return csntc(nick, "Vous n'tes pas autoris  changer ce mode (O).");

		if(strchr(mode, 'k')) i++;
		if(strchr(mode, 'l')) i++;

		if(i > 1 && parc > 4) snprintf(chaninfo->defmodes, 30, "%s %s %s", mode, parv[4], parv[5]);
		else if(i && parc > 3) snprintf(chaninfo->defmodes, 30, "%s %s", mode, parv[4]);
		else Strncpy(chaninfo->defmodes, mode, 29);
		csntc(nick, "Les modes par dfaut de \2%s\2 sont maintenant \2%s\2.", c, parv[3]);
		csmode(chaninfo, "-%s %s", GetCModes(chaninfo), (chaninfo->mode & C_MKEY) ? chaninfo->key : "");
		csmode(chaninfo , "%s", chaninfo->defmodes);
	}

	else if(!strcasecmp(cmd, "welcome"))
	{
		if(parc < 3)
			return csntc(nick, "Syntaxe : %s #salon WELCOME <message|'none'>", RealCmd("chanopt"));

		if(!strcasecmp(parv[3], "none"))
		{
			chaninfo->welcome[0] = '\0';
			DelCSetWelcome(chaninfo);
			csntc(nick, "Le welcome sur \2%s\2 est supprim.", c);
		}
		else
		{
			parv2msgn(parc, parv, 3, chaninfo->welcome, TOPICLEN);
			chaninfo->welcome[TOPICLEN] = 0;
			csntc(nick, "Le message de bienvenue sur \2%s\2 est maintenant : %s", c, chaninfo->welcome);
		}
	}

	else if(!strcasecmp(cmd, "deftopic"))
	{
		if(parc < 3)
			return csntc(nick, "Syntaxe : %s #salon DEFTOPIC <topic>", RealCmd("chanopt"));

		if(CLockTopic(chaninfo)) return csntc(nick, "Le LOCKTOPIC est actif sur %s", c);

		parv2msgn(parc, parv, 3, chaninfo->deftopic, TOPICLEN);
		chaninfo->deftopic[TOPICLEN] = 0;
		csntc(nick, "Le topic par dfaut sur \2%s\2 est maintenant: %s", c, chaninfo->deftopic);
		cstopic(chaninfo, chaninfo->deftopic);
	}

	else if(!strcasecmp(cmd, "motd"))
	{
		if(parc < 3)
			return csntc(nick, "Syntaxe: %s #salon MOTD <motd>", RealCmd("chanopt"));

		if(!strcasecmp(parv[3], "none"))
		{
			if(chaninfo->motd)
			{
				free(chaninfo->motd);
				chaninfo->motd = NULL;
			}
			csntc(nick, "Le motd de \2%s\2 est supprim.", c);
		}
		else
		{
			str_dup(&chaninfo->motd, parv2msg(parc, parv, 3, TOPICLEN));
			csntc(nick, "Le motd de \2%s\2 est maintenant: %s", c, chaninfo->motd);
		}
	}

	else if(!strcasecmp(cmd, "description"))
	{
		if(parc < 3)
			return csntc(nick, "Syntaxe: %s #salon DESCRIPTION <description>", RealCmd("chanopt"));

		parv2msgn(parc, parv, 3, chaninfo->description, DESCRIPTIONLEN);
		chaninfo->description[DESCRIPTIONLEN] = 0;
		csntc(nick, "La description de \2%s\2 est maintenant: %s", c, chaninfo->description);
	}

	else if(!strcasecmp(cmd, "chanurl"))
	{
		if(parc < 3)
			return csntc(nick, "Syntaxe : %s #salon CHANURL <url>", RealCmd("chanopt"));

		if(!strchr(parv[3], '.'))
			return csntc(nick, "%s ne ressemble pas au format d'une URL.", parv[3]);

		Strncpy(chaninfo->url, parv[3], 100);
		csntc(nick, "L'url de\2 %s\2 est maintenant: %s", c, chaninfo->url);
	}

	else if(!strcasecmp(cmd, "banlevel"))
	{
		int l = ChanLevelbyUserI(nick->user, c);
		if(parc < 3)
			return csntc(nick, "Syntaxe : %s #salon BANLEVEL <niveau>", RealCmd("chanopt"));

		if(!is_num(parv[3])) return csntc(nick, "Le niveau doit tre un nombre.");

		if(((i = atoi(parv[3])) > l || chaninfo->banlevel > l) && !IsAnAdmin(nick->user))
			return csntc(nick, "Vous ne pouvez pas changer le banlevel s'il est  un niveau suprieur au votre, ou  un niveau suprieur.");

		chaninfo->banlevel = i;
		csntc(nick, "Le banlevel de\2 %s\2 est maintenant: %d", c, chaninfo->banlevel);
	}

	else if(!strcasecmp(cmd, "bantype"))
	{
		if(parc < 3)
			return csntc(nick, "Syntaxe: %s #salon BANTYPE <n du type>", RealCmd("chanopt"));

		if(!is_num(parv[3]))
			return csntc(nick, "Le type de ban doit tre dfini en prcisant un nombre.");

		if((i = atoi(parv[3])) > 5 || i < 1)
		{
			csntc(nick, "Il n'y a que 5 types diffrents de bans:");
			csntc(nick, " \0021.\2 Ban sur *!*ident@*.host");
			csntc(nick, " \0022.\2 Ban sur *!*ident@*");
			csntc(nick, " \0023.\2 Ban sur *nick*!*@*");
			csntc(nick, " \0024.\2 Ban sur *!*@host");
			csntc(nick, " \0025.\2 Ban sur *!*ident@host");
			return 0;
		}
		chaninfo->bantype = i;
		csntc(nick, "Le type de ban par dfaut de\2 %s\2est maintenant: \2%s\2. (%d)", chaninfo->chan, GetBanType(chaninfo), i);
	}

	else if(!strcasecmp(cmd, "strictop"))
	{
		ToggleFlag(&chaninfo->flag, C_STRICTOP);
		csntc(nick, "Le STRICTOP a t %sactiv sur %s.", CStrictOp(chaninfo) ? "" : "des", c);
	}
	else if(!strcasecmp(cmd, "locktopic"))
	{
		ToggleFlag(&chaninfo->flag, C_LOCKTOPIC);
		csntc(nick, "Le LOCKTOPIC a t %sactiv sur %s.", CLockTopic(chaninfo) ? "" : "des", c);
	}
	else if(!strcasecmp(cmd, "nobans"))
	{
		ToggleFlag(&chaninfo->flag, C_NOBANS);
		csntc(nick, "Le NOBANS a t %sactiv sur %s.", CNoBans(chaninfo) ? "" : "des", c);
	}
	else if(!strcasecmp(cmd, "noops"))
	{
		ToggleFlag(&chaninfo->flag, C_NOOPS);
		csntc(nick, "Le NOOPS a t %sactiv sur %s.", CNoOps(chaninfo) ? "" : "des", c);
	}
	else if(!strcasecmp(cmd, "autoinvite"))
	{
		ToggleFlag(&chaninfo->flag, C_AUTOINVITE);
		csntc(nick, "L'AUTOINVITE a t %sactive sur %s.", CAutoInvite(chaninfo) ? "" : "des", c);
	}

	else if(!strcasecmp(cmd, "chmodeslevel"))
	{
		int l = ChanLevelbyUserI(nick->user, c);
		if(parc < 3)
			return csntc(nick, "Syntaxe : %s #salon CHMODESLEVEL <niveau>", RealCmd("chanopt"));

		if(!is_num(parv[3])) return csntc(nick, "Le niveau doit tre un nombre.");

		if(((i = atoi(parv[3])) > l || chaninfo->cml > l) && !IsAnAdmin(nick->user))
			return csntc(nick, "Vous ne pouvez pas changer le chmodeslevel s'il est  un niveau suprieur au votre, ou  un niveau suprieur.");

		chaninfo->cml = i;
		csntc(nick, "Le chmodeslevel de \2%s\2 est maintenant: %d", c, chaninfo->cml);
	}

	else if(!strcasecmp(cmd, "bantime"))
	{
		time_t timeout = 0;
		if(parc < 3)
			return csntc(nick, "Syntaxe : %s #salon BANTIME <dure>", RealCmd("chanopt"));

		if(!(timeout = convert_duration(parv[3])) && *parv[3] != '0')
			return csntc(nick, "Dure incorrecte, le format est <XjXhXm> X tant le nombre respectif d'units, ou 0 pour dsactiver.");

		chaninfo->bantime = timeout;
		if(timeout) csntc(nick, "Le bantime pour \2%s\2 est maintenant de %lu secondes (%s)", c, chaninfo->bantime, duration(timeout));
		else csntc(nick, "Le bantime est dsactiv sur %s (si aucune dure spcifi, pas d'expiration)", c);
	}

	else if(!strcasecmp(cmd, "autolimit"))
	{
		if(parc < 3)
		{
			ToggleFlag(&chaninfo->flag, C_FLIMIT);
			if(CFLimit(chaninfo) && (!chaninfo->limit_inc || !chaninfo->limit_min))
			{
				chaninfo->limit_inc = DEFAUT_LIMITINC;
				chaninfo->limit_min = DEFAUT_LIMITMIN;
			}
		}
		else if(!strcasecmp(parv[3], "off")) chaninfo->flag &= ~C_FLIMIT;
		else
		{
			int linc = getoption("-limit_inc", parv, parc, 3, 1);
			int lmin = getoption("-limit_min", parv, parc, 3, 1);

			if((strcasecmp(parv[3], "on") && !lmin && !linc) || lmin < 0 || linc < 0)
				return csntc(nick, "Syntaxe : %s #salon AUTOLIMIT [ON|OFF] [-limit_inc <nombre>] [-limit_min <nombre>]", RealCmd("chanopt"));

			if(!CFLimit(chaninfo)) chaninfo->flag |= C_FLIMIT;
			chaninfo->limit_inc = linc ? linc : (chaninfo->limit_inc ? chaninfo->limit_inc : DEFAUT_LIMITINC);
			chaninfo->limit_min = lmin ? lmin : (chaninfo->limit_min ? chaninfo->limit_min : DEFAUT_LIMITMIN);
		}
		if(CFLimit(chaninfo)) csntc(nick, "L'AUTOLIMITE est actif sur %s (Min: %d Inc: %d).", c, chaninfo->limit_min, chaninfo->limit_inc);
		else csntc(nick, "L'AutoLimite a t desactive sur %s.", c);
	}
	else return csntc(nick, "%s n'est pas une option de chanopt valide.", cmd);
	write_achan(chaninfo);
	return 1;
}

int locktopic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "locktopic";

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int strictop(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "strictop";

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int nobans(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "nobans";

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int noops(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "noops";

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int activwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "setwelcome";

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int deftopic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "deftopic";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int defmodes(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "defmodes";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int description(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "description";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int csetwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "welcome";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int banlevel(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "banlevel";
	if(parc == 2) pparv[3] = parv[2];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int bantype(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "bantype";
	if(parc == 2) pparv[3] = parv[2];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int define_motd(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i = 2;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "motd";
	for(;i <= parc;i++) pparv[i+1] = parv[i];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}

int chanurl(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "chanurl";
	pparv[3] = parv[2];

	return generic_chanopt(nick, chaninfo, parc + 1, pparv);
}
